﻿using System;
using UnityEngine;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.CompilerServices;
using System.Security.Policy;
using Battlehub.Utils;
using SimpleJSON;

namespace IdleHelper
{

    public class PhysisLifeMaster : MVRScript
    {

        protected JSONStorableFloat masterIntensity;
        public static JSONStorableFloat masterSpeed;
        protected Atom atom;
        protected JSONStorableFloat gloss;
        protected JSONStorableBool doubleThrustSpeed;


        public override void Init()
        {
            try
            {
                pluginLabelJSON.val = "Master Control";
                atom = containingAtom;
                gloss = atom.GetStorableByID("skin").GetFloatJSONParam("Gloss");
                masterIntensity = new JSONStorableFloat("Master Intensity",0.5f, IntensityChanged, 0,1,false);
                CreateSlider(masterIntensity);
                masterSpeed = new JSONStorableFloat("Master Speed",0, SpeedChanged, 0,1,false);
                CreateSlider(masterSpeed);

                var btn = CreateButton("Sync", true);
                btn.button.onClick.AddListener(() => { SyncTimings(); });

                doubleThrustSpeed = new JSONStorableBool("Double Thrust Speed", false);
                CreateToggle(doubleThrustSpeed, true);

                atom.GetStorableByID("AutoExpressions").SetBoolParamValue("enabled", false);
                atom.GetStorableByID("Eyes").SetStringChooserParamValue("lookMode", "Target");

                // Zero all expressions?


            }
            catch (Exception e)
            {
                SuperController.LogError("Exception caught: " + e);
            }
        }

        void IntensityChanged(float val)
        {
            gloss.val = val * 8f;

            // Breathe
            Breathe.intensity.val = val;

        }

        void SpeedChanged(float val)
        {
            //Breathe.speedAdjust.val = val;
        }

        void SyncTimings()
        {
            SexHelper.lerpTimer = 0;
            Breathe.breatheCycle = 0;
        }

        protected void Start()
        {
        }


        protected void Update()
        {
        }


        // FixedUpdate is called with each physics simulation frame by Unity
        void FixedUpdate()
        {
            try
            {
                // Sex Helper
                if (doubleThrustSpeed.val)
                {
                    SexHelper.durationJSON.val = Breathe.breatheDuration / 4;
                }
                else
                {
                    SexHelper.durationJSON.val = Breathe.breatheDuration / 2;
                }
            }
            catch (Exception e)
            {
                SuperController.LogError("Exception caught: " + e);
            }
        }

    }
}

